#include <maker/handlers/button_handler.hpp>
#include <com/context.hpp>
#include <maker/index.hpp>
#include <utils/context_utils.hpp>
#include <gfx/index.hpp>
#include <gfx/ui/state.hpp>

#include <iostream>

namespace mak {

    ButtonHandler::ButtonHandler() : com::File { self_name() } {}

    ButtonHandler::~ButtonHandler() {}

    void ButtonHandler::on_content_changed(File* sender) {
        // file sent should be status file
        com::Folder* elem_folder = sender->folder();
        gfx::State* state = dynamic_cast<gfx::State*>(sender);
        com::Folder* object_folder = gfx::ui_system()->get_object(elem_folder);
        vec3 color;

        switch (state->get_state()) {
            case gfx::ENABLED:
                color = {0.5f, 0.5f, 0.5f};
                break;
            case gfx::HOVERED:
                color = {0.7f, 0.7f, 0.7f};
                break;
            case gfx::PRESSED:
                color = {0.9f, 0.9f, 0.9f};
                break;
            default:
                break;
        }
        
        // Set object color
        // Figure out a way to change 
        //gfx::object_system()->get_material(object_folder)->set_uniform("color", color);
        gfx::object_system()->get_uniforms(object_folder)->find<com::FileVec3>("material_ambient_color")->set(color);
    }

}